/*;  khdfstream.cc {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.2 $$ {\rhead{\sl khdfstream.cc\quad\thepage}} */
/*;  $$Date: 1997/09/26 04:43:00 $$  */
/*;  $$Source: /home/shiiba/KhProgDevelop/KhC++Lib/dfstream/khdfstream.cc,v $$  */

// @(#) KhDfstream 饹μ

#include <stdio.h>
#include <assert.h>
#include "khdfstream.h"

void KhDfstream::close()  // close the data file
{
  if (openFlag == 1)
    {
      ifstream::close();
      unlink(dfname);
      openFlag = 0;
    }
}

void KhDfstream::open(    // open a data file.
const char *name)       // file name to be opened
{
  // Internally a working file will be created from the data file
  // by ignoring comment strings. Actually users read data from this
  // working file.

  if (openFlag == 1)
    close();

  ifstream fi(name);
  if (!fi)
    { setstate(failbit);  return; }

  if (!tmpnam(dfname))
    { setstate(failbit);  return; }

  ofstream fo(dfname);
  if (!fo)
    { setstate(failbit);  return; }

  char c;
  char clast = '\n';
  while (fi.get(c))
    {
      if (c == '\'' || c == '\"')
        {
          char cmt = c;   fo.put(c);
          while (fi.get(c))
            { fo.put(c);  if (c == cmt) break; }
          assert(c == cmt);
        }
      else if (c == '#')
        {
          while (fi.get(c))
            if (c == '\n') break;

          assert(c == '\n');
          if (clast != '\n')
            fo.put(c);

        }
      else
        fo.put(c);

      clast = c;
    }

  fo.close();
  fi.close();
  cout.flush();
  ifstream::open(dfname);
  openFlag = 1;
}

KhDfstream::~KhDfstream()
{
  if (openFlag == 1) unlink(dfname);
}

/*; end of file */
