/*;  khstr.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.9 $$ {\rhead{\sl khstr.h\quad\thepage}} */
/*;  $$Date: 1998/01/10 05:26:54 $$  */
/*;  $$Source: /home/shiiba/KhProgDevelop/KhC++Lib/string/khstr.h,v $$  */

/*
Υץ khstr.h ϡʸ򰷤ؿƤޤ

ΥץϡScott Robert Ladd ˤ C++ Components and
Algorithms ˷ǺܤƤץ򸵤ˤƤޤ

Υץϡ㳰(try, throw, catch ʤɤȤ)Υɤ
Ǥޤ̾Υ顼(顼å񤤤ơexit )
֤Ƥޤ

ޤ饹 KhString ˥дؿ Strupr  Strlwr ɲäޤ
Strupr ʸʸˡStrlwr ʸʸѴޤ
*/

//  DYNAMIC STRING CLASS -- khstr.h
//  Provides a general dynamic string class.
//  Copyright 1991-1994 Scott Robert Ladd. All Rights Reserved.

#ifndef MSSTR_H
#define MSSTR_H

class KhString;
class KhDebugString;
class KhBoyerMoore;

#include <stddef.h>
#include <iostream.h>
#ifdef _MSC_VER
#include <strstrea.h>
#else
#include <strstream.h>
#endif

#include "khsimple.h"
#include "khboolean.h"

#include "ostype.h"

// ʸ羮Ӥη̤̤ѿ
enum KhStrCompVal { SC_LESS, SC_EQUAL, SC_GREATER, SC_ERROR };

// ʸʸζ̤򤹤뤫ɤ
enum KhStrCompMode { SM_SENSITIVE, SM_IGNORE };

// ʸΥ顼μ
enum KhStrError { SE_OKAY, SE_ALLOC, SE_TOO_LONG, SE_INVALID };

class KhString
{
 friend class KhDebugString;

 public:
  // constructor
  KhString();

  KhString(const KhString & str);
  KhString(const char * cstr);
  KhString(strstream & strm);

  // ʸ fillCh  count ¤٤ʸޤ
  KhString(size_t count,   char fillCh = '\0');

  // ĤηΥ󥹥ȥ饯ϤޤǤʤΤǥȥ
  // Ȥޤ
  // @begin{comment-out-by-Shiiba} -------------------------------
  // KhString(size_t maxsize, const char * format, ... );
  // @end{comment-out-by-Shiiba} ---------------------------------

  // destructor
  ~KhString();

  // version number
  // Scott Robert Ladd Ϳ Version ֹ
  static int Version();

  // value return methods
  size_t Length() const; // ǼƤʸĹ֤ޤ
  size_t Size() const;	 // allocate ƤĹ֤ޤ

  // return const pointer to the c-string
  // const char * ps = (const char *) string;
  // Τ褦ˤƻѤޤ
  operator const char * () const;
  operator char * () const;

  // assignment method
  KhString operator = (const KhString & str);
  KhString operator = (strstream & strm);

  // concatenation methods
 friend KhString operator + (const KhString & str1,
			   const KhString & str2);

 friend KhString operator + (const KhString & str1, char ch);

  void operator += (const KhString & str);
  void operator += (char ch);

  // comparison methods
  int operator <  (const KhString & str) const;
  int operator >  (const KhString & str) const;
  int operator <= (const KhString & str) const;
  int operator >= (const KhString & str) const;
  int operator == (const KhString & str) const;
  int operator != (const KhString & str) const;

  KhStrCompVal Compare(const KhString & str,
		     KhStrCompMode caseChk = SM_IGNORE) const;
  // ʸӡstr1  str2 꼭᤯ФƤ
  // ʤ顢str1.Compare(str2) ϡSC_LESS ֤

  // substring search methods
  KhBoolean Find(const KhBoyerMoore & bm, size_t & pos) const;

  KhBoolean Find(const KhString & str,
	       size_t & pos,
	       KhStrCompMode caseChk = SM_IGNORE) const;

  // substring deletion method
  void Delete(size_t pos, size_t count);

  // substring insertion methods
  void Insert(size_t pos, char ch);
  void Insert(size_t pos, const KhString & str);

  // substring retrieval method
  KhString Cut(size_t start, size_t count) const;
  KhString CutHead(size_t count) const;
  KhString CutTail(size_t count) const;

  // character retrieval method
  char operator [] (size_t pos) const;
  char operator () (size_t pos) const;

  // Strupr and Strlwr were added by T.Sakakibara.
  char * Strupr(char * cstr) const;
  char * Strlwr(char * cstr) const;

  // case-modification methods
  void ToUpper();
  void ToLower();

  KhString AsUpper() const;
  KhString AsLower() const;

  // stream input/output methods

 friend ostream & operator << (ostream & strm, const KhString & str);
 friend istream & operator >> (istream & strm, KhString & str);

  // operator >> λͤѹޤ
  // ϥȥ꡼θ֤߰ʸŤʸɤ߹ߡ ʸ(
  // 򡤥֡ʸ)ɤ߼ä顤ޤǤʸ KhString ˳Ǽ
  // ޤ줬ܡ
  // ϥȥ꡼फǽɤ߼äʸ, (󥰥륯
  // ޤϡ֥륯)ΤȤˤϡĤƱΰɤ߼
  // ޤǤʸ KhString ˳Ǽޤϡȥ꡼˻Ĥ
  // ɤ߼äʸˤϡޤޤ󡣰
  // ȤȤˤʤޤ
  // äơϢ³ư椬񤤤Ƥȡ̥ʸɤ߼ޤ
  // ǸĹʸѤ˻Ѥޤ
  // ɤ߼ʤäˤϡistream  failbit 򥻥åȤޤ

 protected:
  // instance variables
  size_t Siz; // allocated size
  size_t Len; // current length
  char * Txt; // pointer to text

 private:
  // class constant
  static size_t AllocIncr;

  // calc alloc size for needed bytes
  static size_t CalcSiz(size_t needed);
};

// obtain version number
inline int KhString::Version()
{
  return 600; // version 6.00
}

// value return methods
inline size_t KhString::Length() const
{
  return Len;
}

inline size_t KhString::Size() const
{
  return Siz;
}

// add-assignment operator
inline void KhString::operator += (const KhString & str)
{
  *this = *this + str;
}

inline void KhString::operator += (char ch)
{
  *this = *this + ch;
}

inline KhString::operator const char * () const
{
   return Txt;
}

inline KhString::operator char * () const
{
   return Txt;
}

// comparison methods
inline int KhString::operator <  (const KhString & str) const
{
  return (Compare(str) == SC_LESS);
}

inline int KhString::operator >  (const KhString & str) const
{
  return (Compare(str) == SC_GREATER);
}

inline int KhString::operator <= (const KhString & str) const
{
  return (Compare(str) != SC_GREATER);
}

inline int KhString::operator >= (const KhString & str) const
{
  return (Compare(str) != SC_LESS);
}

inline int KhString::operator == (const KhString & str) const
{
  return (Compare(str) == SC_EQUAL);
}

inline int KhString::operator != (const KhString & str) const
{
  return (Compare(str) != SC_EQUAL);
}

// character retrieval method
inline char KhString::operator [] (size_t pos) const
{
  if (pos >= Len)
    return '\x00';
  else
    return Txt[pos];
}

inline char KhString::operator () (size_t pos) const
{
  if (pos >= Len)
    return '\x00';
  else
    return Txt[pos];
}

// stream I/O functions
inline ostream & operator << (ostream & strm, const KhString & str)
{
  if (str.Len > 0)
    strm << str.Txt;
  return strm;
}

class KhBoyerMoore
{
 public:
  // constructors
  KhBoyerMoore(const KhString & pattern);
  KhBoyerMoore(const KhBoyerMoore & bm);

  // destructor
  ~KhBoyerMoore();

  // assignment operator
  void operator = (const KhBoyerMoore & bm);

  // get charactre from pattern string
  char operator [] (size_t index) const;

  // get delta value from table
  size_t GetDelta(char ch) const;

  // get length of pattern used to create table
  size_t GetPatternLen() const;

 private:
  // size of delta table
  static const size_t DeltaSize;

  // pointer to delta table
  size_t * Delta;
  KhString Pattern;
};


// destructor
inline KhBoyerMoore::~KhBoyerMoore()
{
  delete Delta;
}

// get delta value for a given character
inline size_t KhBoyerMoore::GetDelta(char ch) const
{
  return Delta[size_t(ch)];
}

// get length of pattern used to create table
inline size_t KhBoyerMoore::GetPatternLen() const
{
  return Pattern.Length();
}

inline char KhBoyerMoore::operator [] (size_t index) const
{
  return Pattern[index];
};

istream& getline(	// ϥȥ꡼फɤ߼
  istream& strm,	// ϥȥ꡼ؤλ
  KhString& str,	// ɤ߼äԤǼ KhStringؤλ
  char delim = '\n'	// ǥ᥿ʸ
  );

// getline ϲɤޤ꤬¤ϥȥ꡼फǡ
// ɤ߹ߤޤ

int
read_int(	      // ɸϤͤɤߤȤޤ
  const char * prompt // ¥ʤΤʸ
  //
  // : ɤߤȤä͡
  // ɸϤ鲿ǡϤˡ˲ԥ򲡤
  // ϡ顼å񤤤 abort ޤ
  //
);

double
read_double(          // ɸϤ double ͤɤ߼ޤ
  const char * prompt // ¥ʤΤʸ
  //
  // : ɤߤȤä double ͡
  // ɸϤ鲿ǡϤˡ˲ԥ򲡤
  // ϡ顼å񤤤 abort ޤ
  //
);

KhString
read_string(          // ɸϤʸɤ߼ޤ
  const char * prompt // ¥ʤΤʸ
  //
  // : ɤߤȤäʸ
  // ɸϤ鲿ǡϤˡ˲ԥ򲡤
  // ϡ̥ʸ줿Τȸʤޤ顼Ȥϰޤ
  // 
  //
);


#ifdef _UNIX

void
ttyin(		  // /dev/tty ʸɤߤ
  KhString& line  // ɤߤʸǼ뤿ʸ
  //
  // ʸϥХåեˤϻĤޤ󤬡ɤߤʸˤϴ
  // ޤ
  //
);

#endif /* _UNIX */

#endif

/*; end of file */
