/*;  newGridBoxes.cc {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl newGridBoxes.cc\quad\thepage}} */
/*;  $$Date: 1997/09/26 03:48:57 $$  */
/*;  $$Source: /home/shiiba/KhProgDevelop/channelNetwork/tools/newGridBoxes/newGridBoxes.cc,v $$  */

// @(#) շʬ

/*

  < Υץब뤳 >

  շ ABCD (ĺȿײ˽ ABCDȤޤ) ͿƤ
  Ȥޤշϡ̻շǤʤФʤФʤޤ󤬡Ĺ
  ǤɬפϤޤ

   AB  DC 򲼿ޤΤ褦 M ʬбľǷӤ
  Ʊͤˡ AD  BC  N ʬбľǷӤ
  ƤǤ MN ĤΥåɥܥåξɸϤ˽
  ޤ

             D                             C
         N +---+---+---+---+---+-----+---+
           |   |   |   |   |   |     |   |
       N-1 +---+---+---+---+---+-----+---+
           |   |   |   |   |   |     |   |
           |   |   |   |   |   |     |   |
         2 +---+---+---+---+---+-----+---+
           |   |   |   |   |   |     |   |
         1 +---+---+---+---+---+-----+---+
           | A |   |   |   |   |     |   | B
         0 +---+---+---+---+---+-----+---+
            0   1   2   3      ...  M-1   M

  񤭤ϼΤ褦Ǥɬפ˱ơɸϤե˥
  쥯ȤƤ

  åɥܥå (M * N) newgrid
  1 1  (1,1)Υåɥܥå4Ѥκɸ
  1 2  (1,2)Υåɥܥå4Ѥκɸ
  ...
  1 M  (1,M)Υåɥܥå4Ѥκɸ
  2 1  (2,1)Υåɥܥå4Ѥκɸ
  ...
  M N  (M,N)Υåɥܥå4Ѥκɸ

  ޤnewgrid Ȥʸϡɬפ˱ƽ񤭤Ƥ

  <ƤӽФ>

  % newGridBoxes [-h] [fileName]

  -h ꤹȡhelp ɽޤ
  fileName ꤹȡշΥǡե fileName 
  ߤޤǤʤȡprompt ˽äơɸϤǡ
  뤳Ȥˤʤޤ

  ϥե

  @begin{sample_data} --------------------------------------------
  #
  # ʬǡ (newGridBoxes.cc ؤϥǡ)
  #
  # PointA
  10. 5.

  # PointB
  110. 5.

  # PointC
  110. 305.

  # PointD
  10. 305.

  # mdiv (AB ʬ)
  4

  # ndiv (AD ʬ)
  3
  @end{sample_data} ----------------------------------------------

  # ǻϤޤԤϡȹԤǤ

*/

#include <stdlib.h>     /* getopt */
#include "nopath.h"	// nopath
#include "khstr.h"	/* KhString */
#include <iostream.h>
#include "khdfstream.h"	// ifstream, KhDfstream

#ifdef _MSC_VER
#include "getopt.h"
#endif


#include "version.cc"

void usage(const KhString& command)
{
  cerr
  << command << " produces grid boxes vertices data.\n"
  << "usage: " << command << " [options] [fileName]\n"
  << "  -h      show this help message\n"
  << "  If \"fileName\" is given in the command line, \n"
  << "  the input data are read in from the file.\n"
  << "  Otherwise, the input data are read in from STDIN\n"
  << "  with giving pompting messages." << endl;
  exit(1);
}

class Point {
 public:
  Point(	   // constructor
    double aX = 0, // x ɸ
    double aY = 0  // y ɸ
    )
  {
    mX = aX;
    mY = aY;
  }
  Point(const Point& aPoint) {
    mX = aPoint.X();
    mY = aPoint.Y();
  }
  Point& operator = (const Point& aPoint) {
    if (this != &aPoint) {
      mX = aPoint.X();
      mY = aPoint.Y();
    }
    return *this;
  }
  double X() const { return mX; } // x ɸ֤ͤ
  double Y() const { return mY; } // y ɸ֤ͤ
  void SetX(double aX) { mX = aX; } // x ɸͤꤹ
  void SetY(double aY) { mY = aY; } // y ɸͤꤹ
  void Set(double aX, double aY) {
    mX = aX;
    mY = aY;
  }
 friend istream& operator >> (istream& str, Point& aPoint);
 friend ostream& operator << (ostream& str, const Point& aPoint);
 protected:
  double mX;	  // x ɸ
  double mY;	  // y ɸ
};

istream&
operator >> (istream& str, Point& aPoint)
{
  if (!str) {
    return str;
  }
  double x, y;
  str >> x >> y;
  aPoint.Set(x, y);
  return str;
}

ostream&
operator << (ostream& str, const Point& aPoint)
{
  str << " (" << aPoint.X() << ", " << aPoint.Y() << ") ";
  return str;
}

Point
intersect(	        // ʬ PQ  ʬ RS θ
  const Point& aPointP, //  P
  const Point& aPointQ, //  Q
  const Point& aPointR, //  R
  const Point& aPointS  //  S
			// : 
  )
{
  Point T;
  double a11, a12, a21, a22, b1, b2, c;

  a11 = aPointP.X() - aPointQ.X();
  a12 = aPointS.X() - aPointR.X();
  b1 = aPointS.X() - aPointQ.X();
  a21 = aPointP.Y() - aPointQ.Y();
  a22 = aPointS.Y() - aPointR.Y();
  b2 = aPointS.Y() - aPointQ.Y();

  c = (b1*a22 - b2*a12) / (a11*a22 - a21*a12);
  T.SetX(c*aPointP.X() + (1.-c)*aPointQ.X());
  T.SetY(c*aPointP.Y() + (1.-c)*aPointQ.Y());
  return T;
}

int main(int argc, char** argv)
{
  KhString command = nopath(argv[0]);
  char *optstring = "h";
  // optstring ǡץȤƵʸꤷޤ

  int c;

  while((c = getopt(argc, argv, optstring)) != EOF)
  {
    // getopt ϲϤץʸ֤ޤ
    switch (c) {
    case 'h':
      // ץʸ h ֤Ƥν
      // fall through
    default:
      usage(command);
    }
  }

  // argc ˤ, ޥ̾ȰθĿޤĤʤ
  // Ȥargc ˤ 1 ޤ

  if (argc > 2)
  {
    //  command ǤϡθĿ1Ĥޤ0ĤǤ
    usage(command);
  }

  int mdiv;	  // ʬ AB  DC ʬ
  int ndiv;	  // ʬ CD  AD ʬ
  Point pointA, pointB, pointC, pointD;

  if (argc == 2)
  {
    // ե̾Ϳ줿
    KhString file_name = argv[1];

    KhDfstream fi(file_name);
    if (!fi)
    {
      cerr << "Can't open the file: " << file_name << endl;
      return 1;
    }
    fi >> pointA >> pointB >> pointC >> pointD;
    fi >> mdiv;
    fi >> ndiv;
  }
  else
  {
    cerr << "Enter x and y for point A: ";
    cin >> pointA;
    cerr << "Enter x and y for point A: ";
    cin >> pointB;
    cerr << "Enter x and y for point A: ";
    cin >> pointC;
    cerr << "Enter x and y for point A: ";
    cin >> pointD;

    cerr << "Enter mdiv (N of divisions of AB): ";
    cin >> mdiv;
    cerr << "Enter ndiv (N of divisions of DA): ";
    cin >> ndiv;
  }

  cerr << "Original quadlilateral data\n"
       << "A: " << pointA << endl
       << "B: " << pointB << endl
       << "C: " << pointC << endl
       << "D: " << pointD << endl
       << "mdiv: " << mdiv << endl
       << "ndiv: " << ndiv << endl;

  // (mdiv+1)x(ndiv+1)  grid ݤޤ
  Point **grid = new (Point*)[mdiv+1];
  for (int i = 0; i < mdiv+1; i++)
  {
    grid[i] = new Point[ndiv+1];
  }

  for (int i = 0; i < mdiv + 1; i++)
  {
    double x, y;
    x = (pointA.X() * (mdiv - i) + pointB.X() * i) / mdiv;
    y = (pointA.Y() * (mdiv - i) + pointB.Y() * i) / mdiv;
    grid[i][0].Set(x,y);
    x = (pointD.X() * (mdiv - i) + pointC.X() * i) / mdiv;
    y = (pointD.Y() * (mdiv - i) + pointC.Y() * i) / mdiv;
    grid[i][ndiv].Set(x, y);
  }

  for (int j = 0; j < ndiv + 1; j++)
  {
    double x, y;
    x = (pointB.X() * (ndiv - j) + pointC.X() * j) / ndiv;
    y = (pointB.Y() * (ndiv - j) + pointC.Y() * j) / ndiv;
    grid[mdiv][j].Set(x, y);
    x = (pointA.X() * (ndiv - j) + pointD.X() * j) / ndiv;
    y = (pointA.Y() * (ndiv - j) + pointD.Y() * j) / ndiv;
    grid[0][j].Set(x, y);
  }

  for (int i = 1; i < mdiv; i++)
  {
    for (int j = 1; j < ndiv; j++)
    {
      grid[i][j] = intersect(grid[i][0], grid[i][ndiv],
			     grid[0][j], grid[mdiv][j]);
    }
  }

  cout << "# new_grid.dat produced by " << command << "\n"
       << "#\n"
       << mdiv * ndiv << " newgrid" << endl;
  for (int i = 0; i < mdiv; i++)
  {
    for (int j = 0; j < ndiv; j++)
    {
      cout << i + 1 << " " << j + 1 << " "
	   << grid[i][j].X() << " "
	   << grid[i][j].Y() << " "
	   << grid[i+1][j].X() << " "
	   << grid[i+1][j].Y() << " "
	   << grid[i+1][j+1].X() << " "
	   << grid[i+1][j+1].Y() << " "
	   << grid[i][j+1].X() << " "
	   << grid[i][j+1].Y() << endl;
    }
  }

  // (mdiv+1)x(ndiv+1)  grid ޤ
  for (int i = 0; i < mdiv+1; i++)
  {
    delete [] grid[i];
  }
  delete [] grid;

  return 0;
}

/*; end of file */
